#include<bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    string s, ans;
    getline(cin, s);
    cin>>n;
    n=n*(-1);
    long long ost=abs(n)%26;
    for(int i=0; i<s.size(); i++)
    {
        if((s[i]>='a' && s[i]<='z') || (s[i]>='A' && s[i]<='Z'))
        {
            if(n>0)
            {
                ans.push_back(s[i]+ost);
            }
            else
            {
                if((s[i]-ost)>=0) ans.push_back(s[i]-ost);
                else
                {
                    int a=ost;
                    a-=s[i]+1;
                    ans.push_back('z'-a);
                }
            }
        }
        else ans.push_back(s[i]);
    }
    cout<<ans;
    return 0;
}
